<?php

//Define path for theme if in multisite directory
if (file_exists(WHERE_IS_PERSO."themes/".$thename."/theme.cfg")) {
    $multipath = WHERE_IS_PERSO; }
    
//Define paths
$themepath = $multipath."themes/".$thename."/";
$imgpath = $themepath."images/";

//Define username if logged in or anonymous if not
if (!pnUserLoggedIn()) {
    $username = _ANONYMOUS; }
else {
    $username = pnUserGetVar(uname); }

//Load theme templates into strings
$tmpmain = file_get_contents("$themepath"."$theme_file");
$tmpindex = file_get_contents("$themepath"."$index_file");
$tmparticle = file_get_contents("$themepath"."$article_file");
$tmpleft = file_get_contents("$themepath"."$left_file");
$tmpright = file_get_contents("$themepath"."$right_file");
$tmpcenter = file_get_contents("$themepath"."$center_file");
$tmparea1 = file_get_contents("$themepath"."$area1_file");
$tmparea2 = file_get_contents("$themepath"."$area2_file");
$tmparea3 = file_get_contents("$themepath"."$area3_file");
$tmparea4 = file_get_contents("$themepath"."$area4_file");
$tmparea5 = file_get_contents("$themepath"."$area5_file");
$tmparea6 = file_get_contents("$themepath"."$area6_file");
$tmparea7 = file_get_contents("$themepath"."$area7_file");
$tmparea8 = file_get_contents("$themepath"."$area8_file");
$tmparea9 = file_get_contents("$themepath"."$area9_file");
$tmptop = file_get_contents("$themepath"."$top_file");
$tmpbottom = file_get_contents("$themepath"."$bottom_file");

//Prepare main page and header and footer
          //Strip from begining to head or head close
if($strip_head) {
    $tmpmain = strip_to($tmpmain, "/HEAD", null, 0); }
else {
    $tmpmain = strip_to($tmpmain, "HEAD", null, 1); }
    //Strip from body close to end
$tmpmain = strip_from($tmpmain, "/BODY", null, 1);
         //Split into themeheader and themefooter
list ($header, $footer) = split_it($tmpmain, null, $cmds[0]);

//Break apart on comments
$hparts = make_parts($header);
$fparts = make_parts($footer);
$iparts = make_parts($tmpindex);
$aparts = make_parts($tmparticle);
$lparts = make_parts($tmpleft);
$rparts = make_parts($tmpright);
$cparts = make_parts($tmpcenter);
$a1parts = make_parts($tmparea1);
$a2parts = make_parts($tmparea2);
$a3parts = make_parts($tmparea3);
$a4parts = make_parts($tmparea4);
$a5parts = make_parts($tmparea5);
$a6parts = make_parts($tmparea6);
$a7parts = make_parts($tmparea7);
$a8parts = make_parts($tmparea8);
$a9parts = make_parts($tmparea9);
$tpparts = make_parts($tmptop);
$btparts = make_parts($tmpbottom);

//Find commands in comments and remove comments
list ($hparts, $hcommands) = find_commands($hparts, $cmds);
list ($fparts, $fcommands) = find_commands($fparts, $cmds);
list ($iparts, $icommands) = find_commands($iparts, $cmds);
list ($aparts, $acommands) = find_commands($aparts, $cmds);
list ($lparts, $lcommands) = find_commands($lparts, $cmds);
list ($rparts, $rcommands) = find_commands($rparts, $cmds);
list ($cparts, $ccommands) = find_commands($cparts, $cmds);
list ($a1parts, $a1commands) = find_commands($a1parts, $cmds);
list ($a2parts, $a2commands) = find_commands($a2parts, $cmds);
list ($a3parts, $a3commands) = find_commands($a3parts, $cmds);
list ($a4parts, $a4commands) = find_commands($a4parts, $cmds);
list ($a5parts, $a5commands) = find_commands($a5parts, $cmds);
list ($a6parts, $a6commands) = find_commands($a6parts, $cmds);
list ($a7parts, $a7commands) = find_commands($a7parts, $cmds);
list ($a8parts, $a8commands) = find_commands($a8parts, $cmds);
list ($a9parts, $a9commands) = find_commands($a9parts, $cmds);
list ($tpparts, $tpcommands) = find_commands($tpparts, $cmds);
list ($btpparts, $btcommands) = find_commands($btparts, $cmds);

$hparts[0] = "\n\n<!-- Begin AutoTheme Content -->\n\n".$hparts[0];
$fparts[count($fparts)-1] = $fparts[count($fparts)-1]."\n<!-- End AutoTheme Content -->\n\n";

$all_vars = get_defined_vars();

//Functions

//Calculate position after end of last comment (start)
//position at beginning of current comment (cstart) *not needed here*
//position at end of current comment (end)
function make_parts($tmpcontent)
{
    $i = 0;
    $pos = 0;
    $start[0] = 0;
    while(find_any_comment($tmpcontent, $pos) !== false) {
        list($cstart, $end[$i]) = find_any_comment($tmpcontent, $pos);
        $pos = $end[$i];
        $i++;
        $start[$i] = $end[$i - 1] + 1;
    }
    $end[$i] = strlen($tmpcontent);
    //return array($start, $end);
    //Use start and end positions to assign theme parts to array
    $i = 0;
    while($i != count($start)) {
        $newcontent[$i] = substr($tmpcontent, $start[$i], ($end[$i] - $start[$i] + 1));
        $i++;
    }
    return $newcontent;
}

//Find commands in comments and assign to array and remove comments
function find_commands($tmpcontent, $cmds)
{
  $i = 0;
  while($i != count($tmpcontent)) {
    $j = 0;
    while($j != count($cmds)) {
        if(stristr($tmpcontent[$i], $cmds[$j])) {
            $commands[$i] = $cmds[$j]; }
        $j++;
    }
    list($cstart, $cend) = find_any_comment($tmpcontent[$i], 0);
    if($cstart) {
        $newcontent[$i] = substr($tmpcontent[$i], 0, $cstart); }
    else {
        $newcontent[$i] = $tmpcontent[$i]; }
    $i++;
  }
  return array($newcontent, $commands);
}

//Find and return list of start and end positions of a tag
//tag string of form "HTML" or "/HTML"
function find_tag($tmpcontent, $tag)
{
    $temp = stristr($tmpcontent, "<".$tag);
    $pos = strlen($tmpcontent) - strlen($temp);

    if($pos) //if tag found
    {
        $start = $pos;
        $end = strpos($tmpcontent, ">", $start);
        return array($start, $end);
    }
    else
    {
        return false;
    }
}

//Find and return list of start and end positions of a comment
//comment string of form "THIS IS A COMMENT"
function find_comment($tmpcontent, $comment)
{
    while(strpos($tmpcontent, "<!-", $end)) //while still comments
    {
        $start = strpos($tmpcontent, "<!-", $end);
        $end = strpos($tmpcontent, "->", $start) + 1;
        $tmpstr = substr($tmpcontent, $start, $end - $start);
        if(stristr($tmpstr, $comment))
        {
            return array($start, $end);
        }
    }
    return false;
}

//Find and return list of start and end position of next comment
//pos is position in string to start from
function find_any_comment($tmpcontent, $pos)
{
    $start = strpos($tmpcontent, "<!-", $pos);

    if(!is_bool($start)) {
        $end = strpos($tmpcontent, "->", $start) + 1;
//        return $end;
        return array($start, $end); }

    return false;
}

//Split at tag or comment
//tag string of form "HTML" or "/HTML"
//comment string of form "THIS IS A COMMENT"
function split_it($tmpcontent, $tag, $comment)
{
    $first = strip_from($tmpcontent, $tag, $comment, 0);
    $last = strip_to($tmpcontent, $tag, $comment, 1);
    return array($first, $last);
}

//Truncate from tag or comment to end of string
//tag string of form "HTML" or "/HTML"
//comment string of form "THIS IS A COMMENT"
//inc boolean whether to strip the tag its self strip=1
function strip_from($tmpcontent, $tag, $comment, $inc)
{
    if($tag) { //tag was passed
        list ($start, $end) = find_tag($tmpcontent, $tag); }
    elseif($comment) { //comment was passed
        list ($start, $end) = find_comment($tmpcontent, $comment); }
    if($inc) {
        $len = $start; } //strip
    else {
        $len = $end + 1; } //strip up to
    $newcontent = substr($tmpcontent, 0, $len);
    return $newcontent;
}

//Truncate from begining of string up to tag or comment
//tag string of form "HTML" or "/HTML"
//comment string of form "THIS IS A COMMENT"
//inc boolean whether to strip the tag its self strip=1
function strip_to($tmpcontent, $tag, $comment, $inc)
{
    if($tag) { //tag was passed
        list ($start, $end) = find_tag($tmpcontent, $tag); }
    elseif($comment) { //comment was passed
        list ($start, $end) = find_comment($tmpcontent, $comment); }
    if($inc) {
        $len = $end + 1; } //strip
    else {
        $len = $start; } //strip up to
    $newcontent = substr($tmpcontent, $len, strlen($tmpcontent) - $len);
    return $newcontent;
}

//Load file contents into string
function file_get_contents($filename)
{
	$fp = @fopen($filename, "r");
	if (!($fp)) {
		return 0;
    }
	while (!feof($fp)) {
		$temp .= fread($fp, 4096);
    }
    return $temp;
}

//Echo parts and execute commands
function display_parts($parts, $commands)
{
    global $all_vars;
    extract($all_vars);

    $i = 0;
    while($i != count($parts)) {
        $content = "?>".$parts[$i];
        eval($content);

        $j = 0;
        while($j != count($cmds)) {
            if($commands[$i] == $cmds[$j]) {
                $docmd = $actions[$j];
//echo "COMMAND:".$docmd."<br />";
                eval($docmd);
            }
            $j++;
        }
        $i++;
    }
}

?>
